//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DeepSkyBlue
#property indicator_width1 2

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame        = PERIOD_CURRENT;
extern int             PzPeriod         =  14;
extern double          OverBoughtLevel3 =  60;
extern double          OverBoughtLevel2 =  40;
extern double          OverBoughtLevel1 =   0;
extern double          OverSoldLevell   = -5;
extern double          OverSoldLevel2   = -40;
extern double          OverSoldLevel3   = -60;
extern int             alertsOnLevel    = 3;
extern bool            alertsOn         = false;
extern bool            alertsOnCurrent  = false;
extern bool            alertsMessage    = true;
extern bool            alertsSound      = false;
extern bool            alertsEmail      = false;
extern bool            Interpolate      = true;

//
//
//
//
//

double pz[];
double trend[];
string indicatorFileName;
bool   returnBars;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,pz);
   SetIndexBuffer(1,trend);
   
      //
      //
      //
      //
      //

         alertsOnLevel     = MathMax(MathMin(alertsOnLevel,3),1);                  
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
      SetLevelValue(0,OverBoughtLevel1);
      SetLevelValue(1,OverBoughtLevel2);
      SetLevelValue(2,OverBoughtLevel3);
      SetLevelValue(3,OverSoldLevell);
      SetLevelValue(4,OverSoldLevel2);
      SetLevelValue(5,OverSoldLevel3);
   IndicatorShortName(timeFrameToString(TimeFrame)+" price zone osillator ("+PzPeriod+")");      
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][2];
#define _vp 0
#define _tv 1

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { pz[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
      if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
         double alpha = 2.0 / (1.0 + PzPeriod);
         
      //
      //
      //
      //
      //
               
      for (i=limit,r=Bars-i-1;i>=0;i--,r++)
      {
         double sign = 0; 
            if (Close[i]>Close[i+1]) sign =  1;
            if (Close[i]<Close[i+1]) sign = -1;
         double R = sign * Close[i];
         if (r==0)
         {
            work[r][_vp] = R;
            work[r][_tv] = Close[i];
            continue;
         }            
         
         //
         //
         //
         //
         //
         
            work[r][_vp] = work[r-1][_vp]+alpha*(R       -work[r-1][_vp]);
            work[r][_tv] = work[r-1][_tv]+alpha*(Close[i]-work[r-1][_tv]);
            trend[i]     = trend[i+1];

            if (work[r][_tv]!=0)
                  pz[i] = 100.0*work[r][_vp]/work[r][_tv];
            else  pz[i] = 0;                  

            //
            //
            //
            //
            //
            
            switch (alertsOnLevel)
            {
               case 1 :
                     if (pz[i]>OverBoughtLevel1) trend[i] =  1;
                     if (pz[i]<OverSoldLevell)   trend[i] = -1;
                     break;
               case 2 :
                     if (pz[i]>OverBoughtLevel2) trend[i] =  1;
                     if (pz[i]<OverSoldLevel2)   trend[i] = -1;
                     break;
               case 3 :
                     if (pz[i]>OverBoughtLevel3) trend[i] =  1;
                     if (pz[i]<OverSoldLevel3)   trend[i] = -1;
                     break;
            }
      }
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1; 
           
        if (trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar] ==  1) doAlert(whichBar,"over bought level crossed up");
           if (trend[whichBar] == -1) doAlert(whichBar,"over sold level crossed down");
        }
      }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         pz[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,PzPeriod,OverBoughtLevel3,OverBoughtLevel2,OverBoughtLevel1,OverSoldLevell,OverSoldLevel2,OverSoldLevel3,alertsOnLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
         trend[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,PzPeriod,OverBoughtLevel3,OverBoughtLevel2,OverBoughtLevel1,OverSoldLevell,OverSoldLevel2,OverSoldLevel3,alertsOnLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
                    pz[i+k] = pz[i] + (pz[i+n]-pz[i])*k/n;
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static datetime previousTime  = 0;
   static string   previousAlert = "";
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",timeFrameToString(_Period)+" price zone ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"price zone"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
